#
#  gitrelease/hooks/post-update.rb  --  Git Post-Update Hook
#

require "gitrelease/hooks"

# The hook normally will be called internally by git.
# To rebuild all tarballs/gems call the hooks/post-update
# with a parameter "all" and an optional timestamp:
#
#   hooks/post-update all [SINCE]
#

module GitRelease

  class PostUpdate < Hook

    def initialize type
      @type = type
      if $*.first =~ /\Aall/i then
        $*.shift
        @since = $*.shift
      else
        @refs = $*.map { |r| Reference.new r }
      end
    end

    def execute
      if @refs then
        @refs.each { |r|
          g = @type.new r, true
          g.build
        }
      else
        @type.each_ref @since do |g|
          g.build
        end
      end
    end

  end

end

